Attribute VB_Name = "modFadePicture"
'*************************************************************************
'* Draw a faded picture using AlphaBlend API (cfr. transparency effect): *
'*************************************************************************

Option Explicit

Private Const AC_SRC_OVER = &H0

Private Type BLENDFUNCTION

  BlendOp             As Byte
  BlendFlags          As Byte
  SourceConstantAlpha As Byte
  AlphaFormat         As Byte
  
End Type

Private Declare Function AlphaBlend Lib "msimg32.dll" (ByVal hDC As Long, ByVal lInt As Long, ByVal lInt As Long, ByVal lInt As Long, ByVal lInt As Long, ByVal hDC As Long, ByVal lInt As Long, ByVal lInt As Long, ByVal lInt As Long, ByVal lInt As Long, ByVal BLENDFUNCT As Long) As Long
Private Declare Sub RtlMoveMemory Lib "kernel32.dll" (Destination As Any, Source As Any, ByVal Length As Long)

Private BF  As BLENDFUNCTION
Private lBF As Long

Public Sub FadePicture(ByRef oPic1 As PictureBox, ByRef oPic2 As PictureBox, ByVal FadeIndex As Byte)

  With BF
  
    .BlendOp = AC_SRC_OVER
    .BlendFlags = 0
    .SourceConstantAlpha = FadeIndex * 2.55 'Map 0-100 to 0-255
    .AlphaFormat = 0
    
  End With
  
  RtlMoveMemory lBF, BF, 4
  AlphaBlend oPic1.hDC, 0, 0, oPic1.ScaleWidth, oPic1.ScaleHeight, oPic2.hDC, 0, 0, oPic2.ScaleWidth, oPic2.ScaleHeight, lBF
  oPic1.Refresh
  
End Sub
